-- VHDL model created from schematic licz_dek.sch -- Sep 01 19:09:41 2001

LIBRARY ieee;
LIBRARY UNISIM;
LIBRARY XC9000_Macro;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE UNISIM.Vcomponents.ALL;
USE XC9000_Macro.Components.ALL;

entity LICZ_DEK is
      Port (     clk : In    std_logic;
                 res : In    std_logic;
                 wy7 : Out   std_logic;
                 wy6 : Out   std_logic;
                 wy5 : Out   std_logic;
                 wy4 : Out   std_logic;
                 wy3 : Out   std_logic;
                 wy2 : Out   std_logic;
                 wy1 : Out   std_logic;
                 wy0 : Out   std_logic );


end LICZ_DEK;

architecture SCHEMATIC of LICZ_DEK is

   signal      N_1 : std_logic;
   signal      N_2 : std_logic;
   signal      N_3 : std_logic;

   component LICZ_NKB
      Port (     clk : In    std_logic;
                 res : In    std_logic;
                  q0 : Out   std_logic;
                  q1 : Out   std_logic;
                  q2 : Out   std_logic;
                  q3 : Out   std_logic );
   end component;

   component DEK_8
      Port (      a0 : In    std_logic;
                  a1 : In    std_logic;
                  a2 : In    std_logic;
                 wy0 : Out   std_logic;
                 wy1 : Out   std_logic;
                 wy2 : Out   std_logic;
                 wy3 : Out   std_logic;
                 wy4 : Out   std_logic;
                 wy5 : Out   std_logic;
                 wy6 : Out   std_logic;
                 wy7 : Out   std_logic );
   end component;


begin

   I1 : LICZ_NKB
      Port Map ( clk=>clk, res=>res, q0=>N_1, q1=>N_2, q2=>N_3, q3=>open );
   I2 : DEK_8
      Port Map ( a0=>N_1, a1=>N_2, a2=>N_3, wy0=>wy0, wy1=>wy1, wy2=>wy2,
                 wy3=>wy3, wy4=>wy4, wy5=>wy5, wy6=>wy6, wy7=>wy7 );

end SCHEMATIC;
