-- C:\CAD\XILINX_WEBPACK\PROJEKTY\FPGA\LICZ_DEK_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Mon Aug 27 00:52:43 2001

LIBRARY  ieee;

LIBRARY  UNISIM;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE UNISIM.Vcomponents.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT LICZ_DEK
		PORT (
			clk : In  std_logic;
			res : In  std_logic;
			wy : Out  std_logic_vector (7 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL clk : std_logic;
	SIGNAL res : std_logic;
	SIGNAL wy : std_logic_vector (7 DOWNTO 0);

BEGIN
	UUT : LICZ_DEK
	PORT MAP (
		clk => clk,
		res => res,
		wy => wy
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_wy(
			next_wy : std_logic_vector (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy /= next_wy) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy="));
				write(TX_LOC, wy);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		res <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=5 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=85 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=160 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=165 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=167 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=245 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=320 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=325 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=327 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=405 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=480 ns
		res <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=485 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=487 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=565 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=640 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=645 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=647 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=725 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=800 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=805 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=807 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=885 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=960 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=965 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=967 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=1045 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=1120 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=1125 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1127 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=1205 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=1280 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=1285 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1287 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=1365 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=1440 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=1445 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1447 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=1525 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=1600 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=1605 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1607 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=1685 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=1760 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=1765 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1767 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=1845 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=1920 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=1925 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1927 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=2005 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=2080 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2085 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2087 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=2165 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=2240 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2245 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2247 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=2325 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=2400 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2405 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2407 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=2485 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=2560 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2565 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2567 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=2645 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=2720 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2725 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2727 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=2805 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=2880 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2885 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2887 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=2965 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=3040 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=3045 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=3047 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=3125 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=3200 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=3205 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=3207 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=3285 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=3360 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=3365 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=3367 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=3445 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=3520 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=3525 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=3527 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=3605 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=3680 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=3685 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=3687 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=3765 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=3840 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=3845 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=3847 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=3925 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=4000 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=4005 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4007 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=4085 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=4160 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=4165 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4167 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=4245 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=4320 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=4325 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4327 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=4405 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=4480 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=4485 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4487 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=4565 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=4640 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=4645 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4647 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=4725 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=4800 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=4805 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4807 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=4885 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=4960 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=4965 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4967 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=5045 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=5120 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=5125 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=5127 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=5205 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=5280 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=5285 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=5287 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=5365 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=5440 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=5445 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=5447 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=5525 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=5600 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=5605 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=5607 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=5685 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=5760 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=5765 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=5767 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=5845 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=5920 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=5925 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=5927 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=6005 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=6080 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=6085 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=6087 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=6165 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=6240 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=6245 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=6247 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=6325 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=6400 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=6405 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=6407 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=6485 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=6560 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=6565 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=6567 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=6645 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=6720 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=6725 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=6727 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=6805 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=6880 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=6885 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=6887 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=6965 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=7040 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=7045 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7047 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=7125 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=7200 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=7205 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7207 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=7285 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=7360 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=7365 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7367 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=7445 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=7520 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=7525 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7527 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=7605 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=7680 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=7685 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7687 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=7765 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=7840 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=7845 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7847 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=7925 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=8000 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=8005 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=8007 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=8085 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=8160 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=8165 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=8167 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=8245 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=8320 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=8325 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=8327 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=8405 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=8480 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=8485 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=8487 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=8565 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=8640 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=8645 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=8647 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=8725 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=8800 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=8805 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=8807 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=8885 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=8960 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=8965 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=8967 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=9045 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=9120 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=9125 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=9127 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=9205 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=9280 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=9285 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=9287 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=9365 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=9440 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=9445 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=9447 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=9525 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=9600 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=9605 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=9607 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=9685 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=9760 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=9765 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=9767 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=9845 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=9920 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=9925 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=9927 ns
		-- --------------------
		WAIT FOR 78 ns; -- Time=10005 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 75 ns; -- Time=10080 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=10085 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=10087 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION LICZ_DEK_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END LICZ_DEK_cfg;
