--  C:\CAD\XILINX_WEBPACK\PROJEKTY\FPGA\L_NKB_S_TB.VHD
--  VHDL testbench created by 
--  Xilinx's StateBench 1.01
--  Sat Sep 01 15:43:01 2001

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT L_NKB_S
		PORT (q : OUT std_logic_vector (3 DOWNTO 0);
			CLK,RES: IN std_logic);
	END COMPONENT;

	SIGNAL q : std_logic_vector (3 DOWNTO 0) := std_logic_vector'("0000");
	SIGNAL CLK,RES: std_logic := '0';

	BEGIN

	UUT : L_NKB_S PORT MAP (
		q=>q,
		CLK=>CLK,
		RES=>RES);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_q(
			next_q : std_logic_vector (3 DOWNTO 0)
		) IS BEGIN
			IF (q /= next_q) THEN 
				write(TX_OUT,string'(
					"* Error, q="));
				write(TX_OUT, q);
				write(TX_OUT, string'(" Expected = "));
				write(TX_OUT, next_q);
				write(TX_OUT, string'(" *"));
				writeline(results, TX_OUT);
				TX_ERROR := TX_ERROR + 1;
			END IF;
			ASSERT (q=next_q) REPORT
				 "Error, q has incorrect value"
				 SEVERITY ERROR;
		END;

		BEGIN
		-- --------------------
		CLK <= '0'; -- Initialize clock inactive
		RES <= '1';
		WAIT FOR 1 ns;
		-- ----------------------
		CLK <= '1'; -- Clock 0 Time 1 ns
		WAIT FOR 2 ns;
		CHECK_q(std_logic_vector'("0000"));
		WAIT FOR 3 ns;
		CLK <= '0'; -- inactive clock edge
		WAIT FOR 4 ns;
		RES <= '0';
		WAIT FOR 1 ns;
		-- ----------------------
		CLK <= '1'; -- Clock 1 Time 11 ns
		WAIT FOR 2 ns;
		CHECK_q(std_logic_vector'("0001"));
		WAIT FOR 3 ns;
		CLK <= '0'; -- inactive clock edge
		WAIT FOR 4 ns;
		WAIT FOR 1 ns;
		-- ----------------------
		CLK <= '1'; -- Clock 2 Time 21 ns
		WAIT FOR 2 ns;
		CHECK_q(std_logic_vector'("0010"));
		WAIT FOR 3 ns;
		CLK <= '0'; -- inactive clock edge
		WAIT FOR 4 ns;
		WAIT FOR 1 ns;
		-- ----------------------
		CLK <= '1'; -- Clock 3 Time 31 ns
		WAIT FOR 2 ns;
		CHECK_q(std_logic_vector'("0011"));
		WAIT FOR 3 ns;
		CLK <= '0'; -- inactive clock edge
		WAIT FOR 4 ns;
		WAIT FOR 1 ns;
		-- ----------------------
		CLK <= '1'; -- Clock 4 Time 41 ns
		WAIT FOR 2 ns;
		CHECK_q(std_logic_vector'("0100"));
		WAIT FOR 3 ns;
		CLK <= '0'; -- inactive clock edge
		WAIT FOR 4 ns;
		WAIT FOR 1 ns;
		-- ----------------------
		CLK <= '1'; -- Clock 5 Time 51 ns
		WAIT FOR 2 ns;
		CHECK_q(std_logic_vector'("0101"));
		WAIT FOR 3 ns;
		CLK <= '0'; -- inactive clock edge
		WAIT FOR 4 ns;

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful.  No problems detected."
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION L_NKB_S_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END L_NKB_S_cfg;
