--  C:\CAD\XILINX_WEBPACK\PROJEKTY\FPGA\L_NKB.vhd
--  VHDL code created by Xilinx's StateCAD 5.03
--  Mon Aug 27 19:02:02 2001

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  enumerated state assignment with structured code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY SHELL_L_NKB IS
	PORT (CLK,A,B,DOWN,res,RESET: IN std_logic;
		q0,q1,q2,q3 : BUFFER std_logic);
END;

ARCHITECTURE BEHAVIOR OF SHELL_L_NKB IS
	SIGNAL next_q0,next_q1,next_q2,next_q3 : std_logic;
	SIGNAL q : std_logic_vector (3 DOWNTO 0);
BEGIN
	PROCESS (CLK, res)
	BEGIN
		IF (res='1') THEN
			q3 <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			q3 <= next_q3;
		END IF;
	END PROCESS;

	PROCESS (CLK, res)
	BEGIN
		IF (res='1') THEN
			q2 <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			q2 <= next_q2;
		END IF;
	END PROCESS;

	PROCESS (CLK, res)
	BEGIN
		IF (res='1') THEN
			q1 <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			q1 <= next_q1;
		END IF;
	END PROCESS;

	PROCESS (CLK, res)
	BEGIN
		IF (res='1') THEN
			q0 <= '0';
		ELSIF CLK='1' AND CLK'event THEN
			q0 <= next_q0;
		END IF;
	END PROCESS;


	PROCESS (q0,q1,q2,q3,q)
	BEGIN
		q <= (( std_logic_vector'(q3, q2, q1, q0)) +std_logic_vector'("0001"));
		next_q0 <= q(0);
		next_q1 <= q(1);
		next_q2 <= q(2);
		next_q3 <= q(3);
	END PROCESS;
END BEHAVIOR;

LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY ieee;
USE ieee.std_logic_unsigned.all;

ENTITY L_NKB IS
	PORT (q : BUFFER std_logic_vector (3 DOWNTO 0);
		CLK,A,B,DOWN,res,RESET: IN std_logic);
END;

ARCHITECTURE BEHAVIOR OF L_NKB IS
	COMPONENT SHELL_L_NKB
		PORT (CLK,A,B,DOWN,res,RESET: IN std_logic;
			q0,q1,q2,q3 : BUFFER std_logic);
	END COMPONENT;
BEGIN
	SHELL1_L_NKB : SHELL_L_NKB PORT MAP (CLK=>CLK,A=>A,B=>B,DOWN=>DOWN,res=>res,
		RESET=>RESET,q0=>q(0),q1=>q(1),q2=>q(2),q3=>q(3));
END BEHAVIOR;
