-- C:\CAD\XILINX_WEBPACK\PROJEKTY\FPGA\LICZ_DEK_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Wed Aug 22 22:25:45 2001

LIBRARY  ieee;

LIBRARY  UNISIM;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE UNISIM.Vcomponents.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT LICZ_DEK
		PORT (
			clk : In  std_logic;
			res : In  std_logic;
			wy : Out  std_logic_vector (7 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL clk : std_logic;
	SIGNAL res : std_logic;
	SIGNAL wy : std_logic_vector (7 DOWNTO 0);

BEGIN
	UUT : LICZ_DEK
	PORT MAP (
		clk => clk,
		res => res,
		wy => wy
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_wy(
			next_wy : std_logic_vector (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy /= next_wy) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy="));
				write(TX_LOC, wy);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		res <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=40 ns
		CHECK_wy("00000001",40); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=120 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=240 ns
		CHECK_wy("00000011",240); --3
		-- --------------------
		WAIT FOR 80 ns; -- Time=320 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=440 ns
		CHECK_wy("00000111",440); --7
		-- --------------------
		WAIT FOR 80 ns; -- Time=520 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=600 ns
		res <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=640 ns
		CHECK_wy("00001111",640); --F
		-- --------------------
		WAIT FOR 80 ns; -- Time=720 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=800 ns
		res <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=840 ns
		CHECK_wy("00011111",840); --1F
		-- --------------------
		WAIT FOR 80 ns; -- Time=920 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=1000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1040 ns
		CHECK_wy("00111111",1040); --3F
		-- --------------------
		WAIT FOR 80 ns; -- Time=1120 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=1200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1240 ns
		CHECK_wy("01111111",1240); --7F
		-- --------------------
		WAIT FOR 80 ns; -- Time=1320 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=1400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1440 ns
		CHECK_wy("11111111",1440); --FF
		-- --------------------
		WAIT FOR 80 ns; -- Time=1520 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=1600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1640 ns
		CHECK_wy("00000001",1640); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=1720 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=1800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1840 ns
		CHECK_wy("00000001",1840); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=1920 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=2000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2040 ns
		CHECK_wy("00000001",2040); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=2120 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=2200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2240 ns
		CHECK_wy("00000001",2240); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=2320 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=2400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2440 ns
		CHECK_wy("00000001",2440); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=2520 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=2600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2640 ns
		CHECK_wy("00000001",2640); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=2720 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=2800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2840 ns
		CHECK_wy("00000001",2840); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=2920 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 80 ns; -- Time=3000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3040 ns
		CHECK_wy("00000001",3040); --1
		-- --------------------
		WAIT FOR 80 ns; -- Time=3120 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION LICZ_DEK_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END LICZ_DEK_cfg;
