-- Xilinx Vhdl produced by program ngd2vhdl D.27
-- Command: -w licz_dek.nga licz_dek_ppar.vhd 
-- Options: -w -ti UUT 
-- Date: Mon Aug 27 18:13:09 2001 
-- Input file: licz_dek.nga
-- Output file: licz_dek_ppar.vhd
-- Tmp file: C:/WINDOWS/TEMP/xil_15
-- Design name: licz_dek
-- Xilinx: c:/cad/xilinx_webpack
-- # of Entities: 1
-- Device: 2s15vq100-6

-- The output of ngd2vhdl is a simulation model. This file cannot be synthesized,
-- or used in any other manner other than simulation. This netlist uses simulation
-- primitives which may not represent the true implementation of the device, however
-- the netlist is functionally correct. Do not modify this file.

-- Model for  ROC (Reset-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity ROC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 100 ns);
  port(O : out std_ulogic := '1') ;
  attribute VITAL_LEVEL0 of ROC : entity is TRUE;
end ROC;

architecture ROC_V of ROC is
attribute VITAL_LEVEL0 of ROC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    if (WIDTH <= 0 ns) then
       assert FALSE report
       "*** Error: a positive value of WIDTH must be specified ***"
       severity failure;
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end ROC_V;

-- Model for  TOC (Tristate-On-Configuration) Cell
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.VITAL_Timing.all;
entity TOC is
  generic (InstancePath: STRING := "*";
           WIDTH : Time := 0 ns);
  port(O : out std_ulogic := '0');
  attribute VITAL_LEVEL0 of TOC : entity is TRUE;
end TOC;

architecture TOC_V of TOC is
attribute VITAL_LEVEL0 of TOC_V : architecture is TRUE;
begin
  ONE_SHOT : process
  begin
    O <= '1';
    if (WIDTH <= 0 ns) then
       O <= '0';
    else
       wait for WIDTH;
       O <= '0';
    end if;
    wait;
  end process ONE_SHOT;
end TOC_V;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library SIMPRIM;
use SIMPRIM.VCOMPONENTS.ALL;
use SIMPRIM.VPACKAGE.ALL;
entity LICZ_DEK is
  port (
    RES : in STD_LOGIC := 'X'; 
    CLK : in STD_LOGIC := 'X'; 
    WY : out STD_LOGIC_VECTOR ( 7 downto 0 ) 
  );
end LICZ_DEK;

architecture STRUCTURE of LICZ_DEK is
  component ROC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 100 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  component TOC
    generic (InstancePath: STRING := "*";
             WIDTH : Time := 0 ns);
    port (O : out STD_ULOGIC := '1');
  end component;
  signal WY_7_OBUF : STD_LOGIC; 
  signal WY_4_OBUF : STD_LOGIC; 
  signal WY_1_OBUF : STD_LOGIC; 
  signal RES_IBUF : STD_LOGIC; 
  signal WY_5_OBUF : STD_LOGIC; 
  signal WY_2_OBUF : STD_LOGIC; 
  signal CLK_BUFGP_IBUFG : STD_LOGIC; 
  signal WY_6_OBUF : STD_LOGIC; 
  signal WY_3_OBUF : STD_LOGIC; 
  signal WY_0_OBUF : STD_LOGIC; 
  signal CLK_BUFGP : STD_LOGIC; 
  signal I1_I_Q_I1_INST_CY_L_1_O : STD_LOGIC; 
  signal I1_I_Q_0 : STD_LOGIC; 
  signal I1_I_Q_1 : STD_LOGIC; 
  signal I1_I_Q_2 : STD_LOGIC; 
  signal WY_7_OUTMUX : STD_LOGIC; 
  signal WY_7_KEEPER : STD_LOGIC; 
  signal WY_7_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal WY_4_OUTMUX : STD_LOGIC; 
  signal WY_4_KEEPER : STD_LOGIC; 
  signal WY_4_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal WY_1_OUTMUX : STD_LOGIC; 
  signal WY_1_KEEPER : STD_LOGIC; 
  signal WY_1_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal RES_IBUF_0 : STD_LOGIC; 
  signal RES_KEEPER : STD_LOGIC; 
  signal WY_5_OUTMUX : STD_LOGIC; 
  signal WY_5_KEEPER : STD_LOGIC; 
  signal WY_5_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal WY_2_KEEPER : STD_LOGIC; 
  signal WY_2_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal WY_6_KEEPER : STD_LOGIC; 
  signal WY_6_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal WY_3_OUTMUX : STD_LOGIC; 
  signal WY_3_KEEPER : STD_LOGIC; 
  signal WY_3_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal WY_0_OUTMUX : STD_LOGIC; 
  signal WY_0_KEEPER : STD_LOGIC; 
  signal WY_0_OUTBUF_GTS_TRI : STD_LOGIC; 
  signal I1_I_Q_0_LOGIC_ONE : STD_LOGIC; 
  signal I1_I_Q_I1_INST_SUM_1 : STD_LOGIC; 
  signal I1_I_Q_I1_INST_CY_L_0_O : STD_LOGIC; 
  signal I1_I_Q_0_CYMUXG : STD_LOGIC; 
  signal I1_I_Q_0_GROM : STD_LOGIC; 
  signal I1_I_Q_0_FROM : STD_LOGIC; 
  signal I1_I_Q_I1_INST_SUM_0 : STD_LOGIC; 
  signal I1_I_Q_0_FFY_ASYNC_FF_GSR_OR : STD_LOGIC; 
  signal I1_I_Q_0_FFX_ASYNC_FF_GSR_OR : STD_LOGIC; 
  signal I1_I_Q_2_RT : STD_LOGIC; 
  signal I1_I_Q_I1_INST_SUM_2 : STD_LOGIC; 
  signal I1_I_Q_2_FFX_ASYNC_FF_GSR_OR : STD_LOGIC; 
  signal WY_1_OBUF_GROM : STD_LOGIC; 
  signal WY_1_OBUF_FROM : STD_LOGIC; 
  signal WY_3_OBUF_GROM : STD_LOGIC; 
  signal WY_3_OBUF_FROM : STD_LOGIC; 
  signal WY_5_OBUF_GROM : STD_LOGIC; 
  signal WY_5_OBUF_FROM : STD_LOGIC; 
  signal WY_7_OBUF_GROM : STD_LOGIC; 
  signal WY_7_OBUF_FROM : STD_LOGIC; 
  signal WY_7_OBUF_2_INV : STD_LOGIC; 
  signal WY_4_OBUF_2_INV : STD_LOGIC; 
  signal WY_1_OBUF_2_INV : STD_LOGIC; 
  signal WY_5_OBUF_2_INV : STD_LOGIC; 
  signal WY_2_OBUF_2_INV : STD_LOGIC; 
  signal WY_6_OBUF_2_INV : STD_LOGIC; 
  signal WY_3_OBUF_2_INV : STD_LOGIC; 
  signal WY_0_OBUF_2_INV : STD_LOGIC; 
  signal GND : STD_LOGIC; 
  signal VCC : STD_LOGIC; 
  signal GSR : STD_LOGIC; 
  signal GTS : STD_LOGIC; 
begin
  WY_7_KEEPER_1 : X_KEEPER
    port map (
      O => WY_7_KEEPER
    );
  WY_7_OUTMUX_2 : X_BUF
    port map (
      I => WY_7_OBUF,
      O => WY_7_OUTMUX
    );
  WY_7_OBUF_3 : X_BUF
    port map (
      I => WY_7_OUTMUX,
      O => WY_7_OUTBUF_GTS_TRI
    );
  WY_7_OBUF_4 : X_TRI
    port map (
      I => WY_7_OUTBUF_GTS_TRI,
      O => WY(7),
      CTL => WY_7_OBUF_2_INV
    );
  WY_4_KEEPER_5 : X_KEEPER
    port map (
      O => WY_4_KEEPER
    );
  WY_4_OUTMUX_6 : X_BUF
    port map (
      I => WY_4_OBUF,
      O => WY_4_OUTMUX
    );
  WY_4_OBUF_7 : X_BUF
    port map (
      I => WY_4_OUTMUX,
      O => WY_4_OUTBUF_GTS_TRI
    );
  WY_4_OBUF_8 : X_TRI
    port map (
      I => WY_4_OUTBUF_GTS_TRI,
      O => WY(4),
      CTL => WY_4_OBUF_2_INV
    );
  WY_1_KEEPER_9 : X_KEEPER
    port map (
      O => WY_1_KEEPER
    );
  WY_1_OUTMUX_10 : X_BUF
    port map (
      I => WY_1_OBUF,
      O => WY_1_OUTMUX
    );
  WY_1_OBUF_11 : X_BUF
    port map (
      I => WY_1_OUTMUX,
      O => WY_1_OUTBUF_GTS_TRI
    );
  WY_1_OBUF_12 : X_TRI
    port map (
      I => WY_1_OUTBUF_GTS_TRI,
      O => WY(1),
      CTL => WY_1_OBUF_2_INV
    );
  RES_IBUF_13 : X_BUF
    port map (
      I => RES,
      O => RES_IBUF_0
    );
  RES_KEEPER_14 : X_KEEPER
    port map (
      O => RES_KEEPER
    );
  RES_IMUX : X_BUF
    port map (
      I => RES_IBUF_0,
      O => RES_IBUF
    );
  WY_5_KEEPER_15 : X_KEEPER
    port map (
      O => WY_5_KEEPER
    );
  WY_5_OUTMUX_16 : X_BUF
    port map (
      I => WY_5_OBUF,
      O => WY_5_OUTMUX
    );
  WY_5_OBUF_17 : X_BUF
    port map (
      I => WY_5_OUTMUX,
      O => WY_5_OUTBUF_GTS_TRI
    );
  WY_5_OBUF_18 : X_TRI
    port map (
      I => WY_5_OUTBUF_GTS_TRI,
      O => WY(5),
      CTL => WY_5_OBUF_2_INV
    );
  WY_2_KEEPER_19 : X_KEEPER
    port map (
      O => WY_2_KEEPER
    );
  WY_2_OBUF_20 : X_BUF
    port map (
      I => WY_2_OBUF,
      O => WY_2_OUTBUF_GTS_TRI
    );
  WY_2_OBUF_21 : X_TRI
    port map (
      I => WY_2_OUTBUF_GTS_TRI,
      O => WY(2),
      CTL => WY_2_OBUF_2_INV
    );
  WY_6_KEEPER_22 : X_KEEPER
    port map (
      O => WY_6_KEEPER
    );
  WY_6_OBUF_23 : X_BUF
    port map (
      I => WY_6_OBUF,
      O => WY_6_OUTBUF_GTS_TRI
    );
  WY_6_OBUF_24 : X_TRI
    port map (
      I => WY_6_OUTBUF_GTS_TRI,
      O => WY(6),
      CTL => WY_6_OBUF_2_INV
    );
  WY_3_KEEPER_25 : X_KEEPER
    port map (
      O => WY_3_KEEPER
    );
  WY_3_OUTMUX_26 : X_BUF
    port map (
      I => WY_3_OBUF,
      O => WY_3_OUTMUX
    );
  WY_3_OBUF_27 : X_BUF
    port map (
      I => WY_3_OUTMUX,
      O => WY_3_OUTBUF_GTS_TRI
    );
  WY_3_OBUF_28 : X_TRI
    port map (
      I => WY_3_OUTBUF_GTS_TRI,
      O => WY(3),
      CTL => WY_3_OBUF_2_INV
    );
  WY_0_KEEPER_29 : X_KEEPER
    port map (
      O => WY_0_KEEPER
    );
  WY_0_OUTMUX_30 : X_BUF
    port map (
      I => WY_0_OBUF,
      O => WY_0_OUTMUX
    );
  WY_0_OBUF_31 : X_BUF
    port map (
      I => WY_0_OUTMUX,
      O => WY_0_OUTBUF_GTS_TRI
    );
  WY_0_OBUF_32 : X_TRI
    port map (
      I => WY_0_OUTBUF_GTS_TRI,
      O => WY(0),
      CTL => WY_0_OBUF_2_INV
    );
  I1_I_Q_I1_INST_SUM_1_33 : X_XOR2
    port map (
      I0 => I1_I_Q_I1_INST_CY_L_0_O,
      I1 => I1_I_Q_0_GROM,
      O => I1_I_Q_I1_INST_SUM_1
    );
  I1_I_Q_I1_INST_CY_L_1 : X_MUX2
    port map (
      IA => I1_I_Q_1,
      IB => I1_I_Q_I1_INST_CY_L_0_O,
      SEL => I1_I_Q_0_GROM,
      O => I1_I_Q_0_CYMUXG
    );
  I1_I_Q_0_G : X_LUT4
    generic map (
      INIT => X"AAAA"
    )
    port map (
      ADR0 => I1_I_Q_1,
      ADR1 => VCC,
      ADR2 => VCC,
      ADR3 => VCC,
      O => I1_I_Q_0_GROM
    );
  I1_I_Q_0_F : X_LUT4
    generic map (
      INIT => X"AAAA"
    )
    port map (
      ADR0 => I1_I_Q_0,
      ADR1 => VCC,
      ADR2 => VCC,
      ADR3 => VCC,
      O => I1_I_Q_0_FROM
    );
  I1_I_Q_I1_INST_SUM_0_34 : X_XOR2
    port map (
      I0 => I1_I_Q_0_LOGIC_ONE,
      I1 => I1_I_Q_0_FROM,
      O => I1_I_Q_I1_INST_SUM_0
    );
  I1_I_Q_I1_INST_CY_L_0 : X_MUX2
    port map (
      IA => I1_I_Q_0,
      IB => I1_I_Q_0_LOGIC_ONE,
      SEL => I1_I_Q_0_FROM,
      O => I1_I_Q_I1_INST_CY_L_0_O
    );
  I1_I_Q_0_COUTUSED : X_BUF
    port map (
      I => I1_I_Q_0_CYMUXG,
      O => I1_I_Q_I1_INST_CY_L_1_O
    );
  I1_I_Q_0_LOGIC_ONE_35 : X_ONE
    port map (
      O => I1_I_Q_0_LOGIC_ONE
    );
  I1_I_Q_1_36 : X_FF
    port map (
      I => I1_I_Q_I1_INST_SUM_1,
      CLK => CLK_BUFGP,
      CE => VCC,
      SET => GND,
      RST => I1_I_Q_0_FFY_ASYNC_FF_GSR_OR,
      O => I1_I_Q_1
    );
  I1_I_Q_0_FFY_ASYNC_FF_GSR_OR_37 : X_OR2
    port map (
      I0 => RES_IBUF,
      I1 => GSR,
      O => I1_I_Q_0_FFY_ASYNC_FF_GSR_OR
    );
  I1_I_Q_0_38 : X_FF
    port map (
      I => I1_I_Q_I1_INST_SUM_0,
      CLK => CLK_BUFGP,
      CE => VCC,
      SET => GND,
      RST => I1_I_Q_0_FFX_ASYNC_FF_GSR_OR,
      O => I1_I_Q_0
    );
  I1_I_Q_0_FFX_ASYNC_FF_GSR_OR_39 : X_OR2
    port map (
      I0 => RES_IBUF,
      I1 => GSR,
      O => I1_I_Q_0_FFX_ASYNC_FF_GSR_OR
    );
  I1_I_Q_2_RT_40 : X_LUT4
    generic map (
      INIT => X"FF00"
    )
    port map (
      ADR0 => VCC,
      ADR1 => VCC,
      ADR2 => VCC,
      ADR3 => I1_I_Q_2,
      O => I1_I_Q_2_RT
    );
  I1_I_Q_I1_INST_SUM_2_41 : X_XOR2
    port map (
      I0 => I1_I_Q_I1_INST_CY_L_1_O,
      I1 => I1_I_Q_2_RT,
      O => I1_I_Q_I1_INST_SUM_2
    );
  I1_I_Q_2_42 : X_FF
    port map (
      I => I1_I_Q_I1_INST_SUM_2,
      CLK => CLK_BUFGP,
      CE => VCC,
      SET => GND,
      RST => I1_I_Q_2_FFX_ASYNC_FF_GSR_OR,
      O => I1_I_Q_2
    );
  I1_I_Q_2_FFX_ASYNC_FF_GSR_OR_43 : X_OR2
    port map (
      I0 => RES_IBUF,
      I1 => GSR,
      O => I1_I_Q_2_FFX_ASYNC_FF_GSR_OR
    );
  I2_I0_INST_LUT3_0 : X_LUT4
    generic map (
      INIT => X"0003"
    )
    port map (
      ADR0 => VCC,
      ADR1 => I1_I_Q_0,
      ADR2 => I1_I_Q_1,
      ADR3 => I1_I_Q_2,
      O => WY_1_OBUF_GROM
    );
  I2_I0_INST_LUT3_1 : X_LUT4
    generic map (
      INIT => X"0300"
    )
    port map (
      ADR0 => VCC,
      ADR1 => I1_I_Q_1,
      ADR2 => I1_I_Q_2,
      ADR3 => I1_I_Q_0,
      O => WY_1_OBUF_FROM
    );
  WY_1_OBUF_YUSED : X_BUF
    port map (
      I => WY_1_OBUF_GROM,
      O => WY_0_OBUF
    );
  WY_1_OBUF_XUSED : X_BUF
    port map (
      I => WY_1_OBUF_FROM,
      O => WY_1_OBUF
    );
  I2_I0_INST_LUT3_2 : X_LUT4
    generic map (
      INIT => X"0044"
    )
    port map (
      ADR0 => I1_I_Q_0,
      ADR1 => I1_I_Q_1,
      ADR2 => VCC,
      ADR3 => I1_I_Q_2,
      O => WY_3_OBUF_GROM
    );
  I2_I0_INST_LUT3_3 : X_LUT4
    generic map (
      INIT => X"00A0"
    )
    port map (
      ADR0 => I1_I_Q_1,
      ADR1 => VCC,
      ADR2 => I1_I_Q_0,
      ADR3 => I1_I_Q_2,
      O => WY_3_OBUF_FROM
    );
  WY_3_OBUF_YUSED : X_BUF
    port map (
      I => WY_3_OBUF_GROM,
      O => WY_2_OBUF
    );
  WY_3_OBUF_XUSED : X_BUF
    port map (
      I => WY_3_OBUF_FROM,
      O => WY_3_OBUF
    );
  I2_I0_INST_LUT3_4 : X_LUT4
    generic map (
      INIT => X"0022"
    )
    port map (
      ADR0 => I1_I_Q_2,
      ADR1 => I1_I_Q_1,
      ADR2 => VCC,
      ADR3 => I1_I_Q_0,
      O => WY_5_OBUF_GROM
    );
  I2_I0_INST_LUT3_5 : X_LUT4
    generic map (
      INIT => X"0808"
    )
    port map (
      ADR0 => I1_I_Q_2,
      ADR1 => I1_I_Q_0,
      ADR2 => I1_I_Q_1,
      ADR3 => VCC,
      O => WY_5_OBUF_FROM
    );
  WY_5_OBUF_YUSED : X_BUF
    port map (
      I => WY_5_OBUF_GROM,
      O => WY_4_OBUF
    );
  WY_5_OBUF_XUSED : X_BUF
    port map (
      I => WY_5_OBUF_FROM,
      O => WY_5_OBUF
    );
  I2_I0_INST_LUT3_6 : X_LUT4
    generic map (
      INIT => X"2020"
    )
    port map (
      ADR0 => I1_I_Q_1,
      ADR1 => I1_I_Q_0,
      ADR2 => I1_I_Q_2,
      ADR3 => VCC,
      O => WY_7_OBUF_GROM
    );
  I2_I0_INST_LUT3_7 : X_LUT4
    generic map (
      INIT => X"8800"
    )
    port map (
      ADR0 => I1_I_Q_1,
      ADR1 => I1_I_Q_2,
      ADR2 => VCC,
      ADR3 => I1_I_Q_0,
      O => WY_7_OBUF_FROM
    );
  WY_7_OBUF_YUSED : X_BUF
    port map (
      I => WY_7_OBUF_GROM,
      O => WY_6_OBUF
    );
  WY_7_OBUF_XUSED : X_BUF
    port map (
      I => WY_7_OBUF_FROM,
      O => WY_7_OBUF
    );
  CLK_BUF : X_CKBUF
    port map (
      I => CLK,
      O => CLK_BUFGP_IBUFG
    );
  CLK_BUFGP_BUFG_BUF : X_CKBUF
    port map (
      I => CLK_BUFGP_IBUFG,
      O => CLK_BUFGP
    );
  WY_7_OBUF_2_INV_44 : X_INV
    port map (
      I => GTS,
      O => WY_7_OBUF_2_INV
    );
  WY_4_OBUF_2_INV_45 : X_INV
    port map (
      I => GTS,
      O => WY_4_OBUF_2_INV
    );
  WY_1_OBUF_2_INV_46 : X_INV
    port map (
      I => GTS,
      O => WY_1_OBUF_2_INV
    );
  WY_5_OBUF_2_INV_47 : X_INV
    port map (
      I => GTS,
      O => WY_5_OBUF_2_INV
    );
  WY_2_OBUF_2_INV_48 : X_INV
    port map (
      I => GTS,
      O => WY_2_OBUF_2_INV
    );
  WY_6_OBUF_2_INV_49 : X_INV
    port map (
      I => GTS,
      O => WY_6_OBUF_2_INV
    );
  WY_3_OBUF_2_INV_50 : X_INV
    port map (
      I => GTS,
      O => WY_3_OBUF_2_INV
    );
  WY_0_OBUF_2_INV_51 : X_INV
    port map (
      I => GTS,
      O => WY_0_OBUF_2_INV
    );
  VCC_52 : X_ONE
    port map (
      O => VCC
    );
  GND_53 : X_ZERO
    port map (
      O => GND
    );
  ROC_NGD2VHDL : ROC port map (O => GSR);
  TOC_NGD2VHDL : TOC port map (O => GTS);
end STRUCTURE;

