-- C:\KSIAZKA\VHDL\BIDIR\BIDIR_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Thu Mar 14 17:20:34 2002

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT bidir
		PORT (
			dane_wy : in  std_logic_vector (4 DOWNTO 0);
			oe_wy : in  std_logic;
			clk : in  std_logic;
			res : in  std_logic;
			dane_we : out  std_logic_vector (4 DOWNTO 0);
			we_wy : inout  std_logic_vector (4 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL dane_wy : std_logic_vector (4 DOWNTO 0);
	SIGNAL oe_wy : std_logic;
	SIGNAL clk : std_logic;
	SIGNAL res : std_logic;
	SIGNAL dane_we : std_logic_vector (4 DOWNTO 0);
	SIGNAL we_wy : std_logic_vector (4 DOWNTO 0);

BEGIN
	UUT : bidir
	PORT MAP (
		dane_wy => dane_wy,
		oe_wy => oe_wy,
		clk => clk,
		res => res,
		dane_we => dane_we,
		we_wy => we_wy
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_dane_we(
			next_dane_we : std_logic_vector (4 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (dane_we /= next_dane_we) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns dane_we="));
				write(TX_LOC, dane_we);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_dane_we);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_we_wy(
			next_we_wy : std_logic_vector (4 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (we_wy /= next_we_wy) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns we_wy="));
				write(TX_LOC, we_wy);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_we_wy);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		dane_wy <= transport std_logic_vector'("01001"); --9
		oe_wy <= transport '0';
		res <= transport '0';
		we_wy <= transport std_logic_vector'("10000"); --10
		-- --------------------
		WAIT FOR 10 ns; -- Time=10 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=20 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=35 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=50 ns
		dane_wy <= transport std_logic_vector'("10011"); --13
		-- --------------------
		WAIT FOR 10 ns; -- Time=60 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=70 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=85 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=100 ns
		oe_wy <= transport '0';
		res <= transport '1';
		we_wy <= transport std_logic_vector'("10111"); --17
		-- --------------------
		WAIT FOR 10 ns; -- Time=110 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=120 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=135 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=150 ns
		dane_wy <= transport std_logic_vector'("11101"); --1D
		oe_wy <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=160 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=170 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=185 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=200 ns
		dane_wy <= transport std_logic_vector'("00000"); --0
		oe_wy <= transport '0';
		we_wy <= transport std_logic_vector'("01001"); --9
		-- --------------------
		WAIT FOR 10 ns; -- Time=210 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=220 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=235 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=250 ns
		dane_wy <= transport std_logic_vector'("01101"); --D
		oe_wy <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=260 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=270 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=285 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=300 ns
		dane_wy <= transport std_logic_vector'("10110"); --16
		we_wy <= transport std_logic_vector'("00001"); --1
		-- --------------------
		WAIT FOR 10 ns; -- Time=310 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=320 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=335 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=350 ns
		dane_wy <= transport std_logic_vector'("01100"); --C
		-- --------------------
		WAIT FOR 10 ns; -- Time=360 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=370 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=385 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=400 ns
		we_wy <= transport std_logic_vector'("11000"); --18
		-- --------------------
		WAIT FOR 10 ns; -- Time=410 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=420 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=435 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=450 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=460 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=470 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=485 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=500 ns
		we_wy <= transport std_logic_vector'("00101"); --5
		-- --------------------
		WAIT FOR 10 ns; -- Time=510 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=520 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=535 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=550 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=560 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=570 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=585 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=600 ns
		we_wy <= transport std_logic_vector'("00011"); --3
		-- --------------------
		WAIT FOR 10 ns; -- Time=610 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=620 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=635 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=650 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=660 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=670 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=685 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=700 ns
		we_wy <= transport std_logic_vector'("01010"); --A
		-- --------------------
		WAIT FOR 10 ns; -- Time=710 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=720 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=735 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=750 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=760 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=770 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=785 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=800 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=810 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=820 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=835 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=850 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=860 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=870 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=885 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=900 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=910 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=920 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=935 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=950 ns
		-- --------------------
		WAIT FOR 10 ns; -- Time=960 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=970 ns
		-- --------------------
		WAIT FOR 15 ns; -- Time=985 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 15 ns; -- Time=1000 ns
		res <= transport '1';
		-- --------------------
		WAIT FOR 10 ns; -- Time=1010 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION bidir_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END bidir_cfg;
