library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity bidir is
    Port (
	 dane_wy: in std_logic_vector(4 downto 0);
	 oe_wy, clk, res: in std_logic;
	 dane_we: out std_logic_vector(4 downto 0);
	 we_wy: inout std_logic_vector (4 downto 0)
	 );
end bidir;

architecture behavioral of bidir is

begin
rejestr: process (clk, res)
begin
	if (res = '0') then dane_we <= "00000";
	elsif clk='1' and CLK'event then
		dane_we <= we_wy;
	end if;
end process rejestr;

tristate: process (oe_wy, dane_wy)
begin
	if oe_wy = '1' then 
		we_wy <= dane_wy;
	else
		we_wy <= (others => 'Z');
	end if;
end process tristate;

end behavioral;
