-- C:\KSIAZKA\VHDL\BRAMKI\BRAMKI_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Wed Mar 06 18:12:48 2002

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT bramki
		PORT (
			a : in  std_logic;
			b : in  std_logic;
			wy_and : out  std_logic;
			wy_or : out  std_logic;
			wy_xor : out  std_logic;
			wy_not_a : out  std_logic
		);
	END COMPONENT;

	SIGNAL a : std_logic;
	SIGNAL b : std_logic;
	SIGNAL wy_and : std_logic;
	SIGNAL wy_or : std_logic;
	SIGNAL wy_xor : std_logic;
	SIGNAL wy_not_a : std_logic;

BEGIN
	UUT : bramki
	PORT MAP (
		a => a,
		b => b,
		wy_and => wy_and,
		wy_or => wy_or,
		wy_xor => wy_xor,
		wy_not_a => wy_not_a
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_wy_and(
			next_wy_and : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy_and /= next_wy_and) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy_and="));
				write(TX_LOC, wy_and);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy_and);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_wy_or(
			next_wy_or : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy_or /= next_wy_or) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy_or="));
				write(TX_LOC, wy_or);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy_or);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_wy_xor(
			next_wy_xor : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy_xor /= next_wy_xor) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy_xor="));
				write(TX_LOC, wy_xor);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy_xor);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_wy_not_a(
			next_wy_not_a : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy_not_a /= next_wy_not_a) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy_not_a="));
				write(TX_LOC, wy_not_a);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy_not_a);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		a <= transport '0';
		b <= transport '0';
		-- --------------------
		WAIT FOR 50 ns; -- Time=50 ns
		-- --------------------
		WAIT FOR 50 ns; -- Time=100 ns
		a <= transport '1';
		-- --------------------
		WAIT FOR 50 ns; -- Time=150 ns
		-- --------------------
		WAIT FOR 50 ns; -- Time=200 ns
		a <= transport '0';
		b <= transport '1';
		-- --------------------
		WAIT FOR 50 ns; -- Time=250 ns
		-- --------------------
		WAIT FOR 50 ns; -- Time=300 ns
		a <= transport '1';
		b <= transport '1';
		-- --------------------
		WAIT FOR 50 ns; -- Time=350 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION bramki_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END bramki_cfg;
