-- C:\KSIAZKA\VHDL\DEKODER_ADR2\DEKODER_ADR2_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Wed Mar 13 01:37:21 2002

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT dekoder_adr2
		PORT (
			a : in  std_logic_vector (19 DOWNTO 13);
			reset_in : in  std_logic;
			memrd : in  std_logic;
			mem_sel : out  std_logic_vector (3 DOWNTO 1)
		);
	END COMPONENT;

	SIGNAL a : std_logic_vector (19 DOWNTO 13);
	SIGNAL reset_in : std_logic;
	SIGNAL memrd : std_logic;
	SIGNAL mem_sel : std_logic_vector (3 DOWNTO 1);

BEGIN
	UUT : dekoder_adr2
	PORT MAP (
		a => a,
		reset_in => reset_in,
		memrd => memrd,
		mem_sel => mem_sel
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_mem_sel(
			next_mem_sel : std_logic_vector (2 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (mem_sel /= next_mem_sel) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns mem_sel="));
				write(TX_LOC, mem_sel);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_mem_sel);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		a <= transport std_logic_vector'("1101100"); --6C
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=25 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=50 ns
		a <= transport std_logic_vector'("1101100"); --6C
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=75 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=100 ns
		a <= transport std_logic_vector'("1100010"); --62
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=125 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=150 ns
		a <= transport std_logic_vector'("1100010"); --62
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=175 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=200 ns
		a <= transport std_logic_vector'("1100110"); --66
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=225 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=250 ns
		a <= transport std_logic_vector'("1100110"); --66
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=275 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=300 ns
		a <= transport std_logic_vector'("1100110"); --66
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=325 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=350 ns
		a <= transport std_logic_vector'("1100110"); --66
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=375 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=400 ns
		a <= transport std_logic_vector'("1100111"); --67
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=425 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=450 ns
		a <= transport std_logic_vector'("1101000"); --68
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=475 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=500 ns
		a <= transport std_logic_vector'("1101001"); --69
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=525 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=550 ns
		a <= transport std_logic_vector'("1101010"); --6A
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=575 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=600 ns
		a <= transport std_logic_vector'("1101011"); --6B
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=625 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=650 ns
		a <= transport std_logic_vector'("1101100"); --6C
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=675 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=700 ns
		a <= transport std_logic_vector'("1101101"); --6D
		reset_in <= transport '0';
		memrd <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=725 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=750 ns
		reset_in <= transport '1';
		memrd <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=775 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=800 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=825 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=850 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=875 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=900 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=925 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=950 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=975 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1000 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1025 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1050 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1075 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1100 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1125 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1150 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1175 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1200 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1225 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1250 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1275 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1300 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1325 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1350 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1375 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1400 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1425 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1450 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1475 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1500 ns
		reset_in <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1525 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1550 ns
		reset_in <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1575 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION dekoder_adr2_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END dekoder_adr2_cfg;
