library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity licz_dek_hier is
    port (
 	clk, kier_licz, zerowanie: 	in std_logic;
	led_a, led_b, led_c, led_d: 	out std_logic;
	led_e, led_f, led_g: 			out std_logic
);
end licz_dek_hier;

architecture a of licz_dek_hier is
component licznik port (	
		clk: in std_logic;
     	res: in std_logic;
		u_d: in std_logic;
	   q: buffer std_logic_vector(3 downto 0)
		);
end component licznik;

component segment port (
		a3, a2, a1, a0, inh: in std_logic;
   	a, b, c, d, e, f, g: out std_logic
	 	);
end component segment;

signal magistrala: std_logic_vector(3 downto 0);

begin
licz: licznik port map (
       clk => clk,
       u_d => kier_licz,
		 res => zerowanie,
		 q => magistrala
    );

dek: segment port map (
		  a3 => magistrala(3),
		  a2 => magistrala(2),
		  a1 => magistrala(1),
		  a0 => magistrala(0),
		  a => led_a,
		  b => led_b,
		  c => led_c,
		  d => led_d,
		  e => led_e,
		  f => led_f,
		  g => led_g,
		  inh => '0'
	);

end a;
