-- C:\KSIAZKA\VHDL\MUX_2X4_2X1\MUX_2X4_2X1_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Sat Mar 16 01:18:53 2002

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT mux_2x4_2x1
		PORT (
			x : in  std_logic_vector (3 DOWNTO 0);
			y : in  std_logic_vector (3 DOWNTO 0);
			a : in  std_logic_vector (1 DOWNTO 0);
			en : in  std_logic;
			wy_x : out  std_logic;
			wy_y : out  std_logic
		);
	END COMPONENT;

	SIGNAL x : std_logic_vector (3 DOWNTO 0);
	SIGNAL y : std_logic_vector (3 DOWNTO 0);
	SIGNAL a : std_logic_vector (1 DOWNTO 0);
	SIGNAL en : std_logic;
	SIGNAL wy_x : std_logic;
	SIGNAL wy_y : std_logic;

BEGIN
	UUT : mux_2x4_2x1
	PORT MAP (
		x => x,
		y => y,
		a => a,
		en => en,
		wy_x => wy_x,
		wy_y => wy_y
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_wy_x(
			next_wy_x : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy_x /= next_wy_x) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy_x="));
				write(TX_LOC, wy_x);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy_x);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_wy_y(
			next_wy_y : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy_y /= next_wy_y) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy_y="));
				write(TX_LOC, wy_y);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy_y);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		x <= transport std_logic_vector'("0000"); --0
		y <= transport std_logic_vector'("1111"); --F
		a <= transport std_logic_vector'("00"); --0
		en <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=25 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=50 ns
		x <= transport std_logic_vector'("0001"); --1
		y <= transport std_logic_vector'("1110"); --E
		en <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=75 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=100 ns
		x <= transport std_logic_vector'("0010"); --2
		y <= transport std_logic_vector'("1101"); --D
		a <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 25 ns; -- Time=125 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=150 ns
		x <= transport std_logic_vector'("0011"); --3
		y <= transport std_logic_vector'("1100"); --C
		-- --------------------
		WAIT FOR 25 ns; -- Time=175 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=200 ns
		x <= transport std_logic_vector'("0100"); --4
		y <= transport std_logic_vector'("1011"); --B
		a <= transport std_logic_vector'("10"); --2
		en <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=225 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=250 ns
		x <= transport std_logic_vector'("0101"); --5
		y <= transport std_logic_vector'("1010"); --A
		-- --------------------
		WAIT FOR 25 ns; -- Time=275 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=300 ns
		x <= transport std_logic_vector'("0110"); --6
		y <= transport std_logic_vector'("1001"); --9
		a <= transport std_logic_vector'("11"); --3
		en <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=325 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=350 ns
		x <= transport std_logic_vector'("0111"); --7
		y <= transport std_logic_vector'("1000"); --8
		en <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=375 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=400 ns
		x <= transport std_logic_vector'("1000"); --8
		y <= transport std_logic_vector'("0111"); --7
		a <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 25 ns; -- Time=425 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=450 ns
		x <= transport std_logic_vector'("1001"); --9
		y <= transport std_logic_vector'("0110"); --6
		en <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=475 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=500 ns
		x <= transport std_logic_vector'("1010"); --A
		a <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 25 ns; -- Time=525 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=550 ns
		x <= transport std_logic_vector'("1011"); --B
		en <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=575 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=600 ns
		x <= transport std_logic_vector'("1100"); --C
		a <= transport std_logic_vector'("10"); --2
		-- --------------------
		WAIT FOR 25 ns; -- Time=625 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=650 ns
		x <= transport std_logic_vector'("1101"); --D
		-- --------------------
		WAIT FOR 25 ns; -- Time=675 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=700 ns
		x <= transport std_logic_vector'("1110"); --E
		a <= transport std_logic_vector'("11"); --3
		-- --------------------
		WAIT FOR 25 ns; -- Time=725 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=750 ns
		x <= transport std_logic_vector'("1111"); --F
		-- --------------------
		WAIT FOR 25 ns; -- Time=775 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=800 ns
		a <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 25 ns; -- Time=825 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=850 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=875 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=900 ns
		a <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 25 ns; -- Time=925 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=950 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=975 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1000 ns
		a <= transport std_logic_vector'("10"); --2
		-- --------------------
		WAIT FOR 25 ns; -- Time=1025 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1050 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1075 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1100 ns
		a <= transport std_logic_vector'("11"); --3
		-- --------------------
		WAIT FOR 25 ns; -- Time=1125 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1150 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1175 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1200 ns
		a <= transport std_logic_vector'("00"); --0
		-- --------------------
		WAIT FOR 25 ns; -- Time=1225 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1250 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1275 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1300 ns
		a <= transport std_logic_vector'("01"); --1
		-- --------------------
		WAIT FOR 25 ns; -- Time=1325 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1350 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1375 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1400 ns
		a <= transport std_logic_vector'("10"); --2
		-- --------------------
		WAIT FOR 25 ns; -- Time=1425 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1450 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1475 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=1500 ns
		a <= transport std_logic_vector'("11"); --3
		-- --------------------
		WAIT FOR 25 ns; -- Time=1525 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION mux_2x4_2x1_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END mux_2x4_2x1_cfg;
