library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity przerzutniki is
    Port (
	 clk, j, k, set, res, t: in std_logic;
	 d_D, d_L: in std_logic;
  	 q_D, q_L, q_T, q_RS, q_JK: buffer std_logic
	 );
end przerzutniki;

architecture behavioral of przerzutniki is
begin
-- Opis przerzutnika typu D
d_reg: process (clk, set, res)
begin
	if (res = '0') then 
		q_D <= '0';
	elsif (set = '0') then
		q_D <= '1';
	elsif (clk'event and clk = '1') then
		q_D <= d_D;
	end if;
end process d_reg;

-- Opis przerzutnika typu T
t_reg: process (clk, set, res, t)
begin
	if (res = '0') then 
		q_T <= '0';
	elsif (set = '0') then
		q_T <= '1';
	elsif (clk'event and clk = '1') then
		if (t = '1') then 
		q_T <= not(q_T);
		else
		q_T <= q_T;
		end if;
	end if;
end process t_reg;

-- Opis przerzutnika typu JK
jk_reg: process (clk, set, res)
begin
	if (res = '0') then 
		q_JK <= '0';
	elsif (set = '0') then
		q_JK <= '1';
	elsif (clk'event and clk = '1') then
		if (j = '1' and k = '1') then
		q_JK <= not(q_JK);
		elsif (j = '1') then 
		q_JK <= '1';
		elsif (k = '1') then
		q_JK <= '0';
		end if;
	end if;
end process jk_reg;

-- Opis przerzutnika typu Latch
l_reg: process (clk, set, res, d_L)
begin
	if (res = '0') then 
		q_L <= '0';
	elsif (set = '0') then
		q_L <= '1';
	elsif (clk = '1') then
		q_L <= d_L;
	end if;
end process l_reg;

-- Opis przerzutnika typu RS
rs_reg: process (set, res)
begin
	if (res = '0') then 
		q_RS <= '0';
	elsif (set = '0') then
		q_RS <= '1';
	end if;
end process rs_reg;
end behavioral;
