-- C:\KSIAZKA\VHDL\REJ_SPI_SO\REJ_SPI_SO_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Sat Mar 16 02:54:33 2002

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT rej_spi_so
		PORT (
			serin : in  std_logic;
			load : in  std_logic;
			clk : in  std_logic;
			serout : out  std_logic;
			data : in  std_logic_vector (3 DOWNTO 0)
		);
	END COMPONENT;

	SIGNAL serin : std_logic;
	SIGNAL load : std_logic;
	SIGNAL clk : std_logic;
	SIGNAL serout : std_logic;
	SIGNAL data : std_logic_vector (3 DOWNTO 0);

BEGIN
	UUT : rej_spi_so
	PORT MAP (
		serin => serin,
		load => load,
		clk => clk,
		serout => serout,
		data => data
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_serout(
			next_serout : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (serout /= next_serout) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns serout="));
				write(TX_LOC, serout);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_serout);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		serin <= transport '0';
		load <= transport '1';
		data <= transport std_logic_vector'("0000"); --0
		-- --------------------
		WAIT FOR 2 ns; -- Time=2 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=4 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=27 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=50 ns
		serin <= transport '1';
		load <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=52 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=54 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=77 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=100 ns
		load <= transport '0';
		-- --------------------
		WAIT FOR 2 ns; -- Time=102 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=104 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=127 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=150 ns
		data <= transport std_logic_vector'("0000"); --0
		-- --------------------
		WAIT FOR 2 ns; -- Time=152 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=154 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=177 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=200 ns
		serin <= transport '0';
		-- --------------------
		WAIT FOR 2 ns; -- Time=202 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=204 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=227 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=250 ns
		serin <= transport '1';
		data <= transport std_logic_vector'("0001"); --1
		-- --------------------
		WAIT FOR 2 ns; -- Time=252 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=254 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=277 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=300 ns
		-- --------------------
		WAIT FOR 2 ns; -- Time=302 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=304 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=327 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=350 ns
		serin <= transport '0';
		data <= transport std_logic_vector'("0010"); --2
		-- --------------------
		WAIT FOR 2 ns; -- Time=352 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=354 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=377 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=400 ns
		load <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=402 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=404 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=427 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=450 ns
		load <= transport '0';
		data <= transport std_logic_vector'("0011"); --3
		-- --------------------
		WAIT FOR 2 ns; -- Time=452 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=454 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=477 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=500 ns
		-- --------------------
		WAIT FOR 2 ns; -- Time=502 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=504 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=527 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=550 ns
		data <= transport std_logic_vector'("0100"); --4
		-- --------------------
		WAIT FOR 2 ns; -- Time=552 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=554 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=577 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=600 ns
		-- --------------------
		WAIT FOR 2 ns; -- Time=602 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=604 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=627 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=650 ns
		data <= transport std_logic_vector'("0101"); --5
		-- --------------------
		WAIT FOR 2 ns; -- Time=652 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=654 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=677 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=700 ns
		-- --------------------
		WAIT FOR 2 ns; -- Time=702 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=704 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=727 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=750 ns
		data <= transport std_logic_vector'("0110"); --6
		-- --------------------
		WAIT FOR 2 ns; -- Time=752 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=754 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=777 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=800 ns
		-- --------------------
		WAIT FOR 2 ns; -- Time=802 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=804 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=827 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=850 ns
		load <= transport '1';
		data <= transport std_logic_vector'("0111"); --7
		-- --------------------
		WAIT FOR 2 ns; -- Time=852 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=854 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=877 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=900 ns
		-- --------------------
		WAIT FOR 2 ns; -- Time=902 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=904 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=927 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=950 ns
		load <= transport '0';
		-- --------------------
		WAIT FOR 2 ns; -- Time=952 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=954 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=977 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=1000 ns
		-- --------------------
		WAIT FOR 2 ns; -- Time=1002 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1004 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=1027 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=1050 ns
		data <= transport std_logic_vector'("0001"); --1
		-- --------------------
		WAIT FOR 2 ns; -- Time=1052 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1054 ns
		-- --------------------
		WAIT FOR 23 ns; -- Time=1077 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 23 ns; -- Time=1100 ns
		data <= transport std_logic_vector'("1001"); --9
		-- --------------------
		WAIT FOR 2 ns; -- Time=1102 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION rej_spi_so_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END rej_spi_so_cfg;
