-- C:\KSIAZKA\VHDL\WIRED_MUX1\WIRED_MUX1_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Thu Mar 14 15:39:59 2002

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.all;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT wired_mux1
		PORT (
			we2 : in  std_logic;
			we1 : in  std_logic;
			adr : in  std_logic;
			wy : out  std_logic
		);
	END COMPONENT;

	SIGNAL we2 : std_logic;
	SIGNAL we1 : std_logic;
	SIGNAL adr : std_logic;
	SIGNAL wy : std_logic;

BEGIN
	UUT : wired_mux1
	PORT MAP (
		we2 => we2,
		we1 => we1,
		adr => adr,
		wy => wy
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_wy(
			next_wy : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wy /= next_wy) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wy="));
				write(TX_LOC, wy);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wy);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		we2 <= transport '1';
		we1 <= transport '1';
		adr <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=25 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=50 ns
		adr <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=75 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=100 ns
		we1 <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=125 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=150 ns
		we1 <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=175 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=200 ns
		we2 <= transport '0';
		we1 <= transport '0';
		adr <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=225 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=250 ns
		we2 <= transport '1';
		we1 <= transport '1';
		adr <= transport '1';
		-- --------------------
		WAIT FOR 25 ns; -- Time=275 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=300 ns
		we2 <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=325 ns
		-- --------------------
		WAIT FOR 25 ns; -- Time=350 ns
		adr <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=375 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION wired_mux1_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END wired_mux1_cfg;
